<?php
/**
 * Adore Themes Customizer
 *
 * @package Translucent Blog
 *
 * List Posts Section
 */

$wp_customize->add_section(
	'translucent_blog_list_posts_section',
	array(
		'title' => esc_html__( 'List Posts Section', 'translucent-blog' ),
		'panel' => 'translucent_blog_frontpage_panel',
	)
);

// List Posts section enable settings.
$wp_customize->add_setting(
	'translucent_blog_list_posts_section_enable',
	array(
		'default'           => false,
		'sanitize_callback' => 'translucent_blog_sanitize_checkbox',
	)
);

$wp_customize->add_control(
	new Translucent_Blog_Toggle_Checkbox_Custom_control(
		$wp_customize,
		'translucent_blog_list_posts_section_enable',
		array(
			'label'    => esc_html__( 'Enable List Posts Section', 'translucent-blog' ),
			'type'     => 'checkbox',
			'settings' => 'translucent_blog_list_posts_section_enable',
			'section'  => 'translucent_blog_list_posts_section',
		)
	)
);

// List Posts title settings.
$wp_customize->add_setting(
	'translucent_blog_list_posts_title',
	array(
		'default'           => __( 'List Posts', 'translucent-blog' ),
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'translucent_blog_list_posts_title',
	array(
		'label'           => esc_html__( 'Section Title', 'translucent-blog' ),
		'section'         => 'translucent_blog_list_posts_section',
		'active_callback' => 'translucent_blog_if_list_posts_enabled',
	)
);

// Abort if selective refresh is not available.
if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'translucent_blog_list_posts_title',
		array(
			'selector'            => '.list-post h3.section-title',
			'settings'            => 'translucent_blog_list_posts_title',
			'container_inclusive' => false,
			'fallback_refresh'    => true,
			'render_callback'     => 'translucent_blog_list_posts_title_text_partial',
		)
	);
}

// List Posts subtitle settings.
$wp_customize->add_setting(
	'translucent_blog_list_posts_subtitle',
	array(
		'default'           => '',
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'translucent_blog_list_posts_subtitle',
	array(
		'label'           => esc_html__( 'Section Subtitle', 'translucent-blog' ),
		'section'         => 'translucent_blog_list_posts_section',
		'active_callback' => 'translucent_blog_if_list_posts_enabled',
	)
);

// View All button label setting.
$wp_customize->add_setting(
	'translucent_blog_list_posts_view_all_button_label',
	array(
		'default'           => __( 'View All', 'translucent-blog' ),
		'sanitize_callback' => 'sanitize_text_field',
	)
);

$wp_customize->add_control(
	'translucent_blog_list_posts_view_all_button_label',
	array(
		'label'           => esc_html__( 'View All Button Label', 'translucent-blog' ),
		'section'         => 'translucent_blog_list_posts_section',
		'settings'        => 'translucent_blog_list_posts_view_all_button_label',
		'type'            => 'text',
		'active_callback' => 'translucent_blog_if_list_posts_enabled',
	)
);

// Abort if selective refresh is not available.
if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'translucent_blog_list_posts_view_all_button_label',
		array(
			'selector'            => '.list-post .adore-view-all',
			'settings'            => 'translucent_blog_list_posts_view_all_button_label',
			'container_inclusive' => false,
			'fallback_refresh'    => true,
			'render_callback'     => 'translucent_blog_list_posts_view_all_button_label_text_partial',
		)
	);
}

// View All button URL setting.
$wp_customize->add_setting(
	'translucent_blog_list_posts_view_all_button_url',
	array(
		'default'           => '#',
		'sanitize_callback' => 'esc_url_raw',
	)
);

$wp_customize->add_control(
	'translucent_blog_list_posts_view_all_button_url',
	array(
		'label'           => esc_html__( 'View All Button Link', 'translucent-blog' ),
		'section'         => 'translucent_blog_list_posts_section',
		'settings'        => 'translucent_blog_list_posts_view_all_button_url',
		'type'            => 'url',
		'active_callback' => 'translucent_blog_if_list_posts_enabled',
	)
);

// list_posts content type settings.
$wp_customize->add_setting(
	'translucent_blog_list_posts_content_type',
	array(
		'default'           => 'post',
		'sanitize_callback' => 'translucent_blog_sanitize_select',
	)
);

$wp_customize->add_control(
	'translucent_blog_list_posts_content_type',
	array(
		'label'           => esc_html__( 'Content type:', 'translucent-blog' ),
		'description'     => esc_html__( 'Choose where you want to render the content from.', 'translucent-blog' ),
		'section'         => 'translucent_blog_list_posts_section',
		'type'            => 'select',
		'active_callback' => 'translucent_blog_if_list_posts_enabled',
		'choices'         => array(
			'post'     => esc_html__( 'Post', 'translucent-blog' ),
			'category' => esc_html__( 'Category', 'translucent-blog' ),
		),
	)
);

for ( $i = 1; $i <= 4; $i++ ) {
	// list_posts post setting.
	$wp_customize->add_setting(
		'translucent_blog_list_posts_post_' . $i,
		array(
			'sanitize_callback' => 'translucent_blog_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'translucent_blog_list_posts_post_' . $i,
		array(
			'label'           => sprintf( esc_html__( 'Post %d', 'translucent-blog' ), $i ),
			'section'         => 'translucent_blog_list_posts_section',
			'type'            => 'select',
			'choices'         => translucent_blog_get_post_choices(),
			'active_callback' => 'translucent_blog_list_posts_section_content_type_post_enabled',
		)
	);

}

// list_posts category setting.
$wp_customize->add_setting(
	'translucent_blog_list_posts_category',
	array(
		'sanitize_callback' => 'translucent_blog_sanitize_select',
	)
);

$wp_customize->add_control(
	'translucent_blog_list_posts_category',
	array(
		'label'           => esc_html__( 'Category', 'translucent-blog' ),
		'section'         => 'translucent_blog_list_posts_section',
		'type'            => 'select',
		'choices'         => translucent_blog_get_post_cat_choices(),
		'active_callback' => 'translucent_blog_list_posts_section_content_type_category_enabled',
	)
);

/*========================Active Callback==============================*/
function translucent_blog_if_list_posts_enabled( $control ) {
	return $control->manager->get_setting( 'translucent_blog_list_posts_section_enable' )->value();
}
function translucent_blog_list_posts_section_content_type_post_enabled( $control ) {
	$content_type = $control->manager->get_setting( 'translucent_blog_list_posts_content_type' )->value();
	return translucent_blog_if_list_posts_enabled( $control ) && ( 'post' === $content_type );
}
function translucent_blog_list_posts_section_content_type_category_enabled( $control ) {
	$content_type = $control->manager->get_setting( 'translucent_blog_list_posts_content_type' )->value();
	return translucent_blog_if_list_posts_enabled( $control ) && ( 'category' === $content_type );
}

/*========================Partial Refresh==============================*/
if ( ! function_exists( 'translucent_blog_list_posts_title_text_partial' ) ) :
	// Title.
	function translucent_blog_list_posts_title_text_partial() {
		return esc_html( get_theme_mod( 'translucent_blog_list_posts_title' ) );
	}
endif;
if ( ! function_exists( 'translucent_blog_list_posts_view_all_button_label_text_partial' ) ) :
	// View All.
	function translucent_blog_list_posts_view_all_button_label_text_partial() {
		return esc_html( get_theme_mod( 'translucent_blog_list_posts_view_all_button_label' ) );
	}
endif;
